Bug 905420

Summary: RFE: Correct ppl-%{_arch}.hh definition conflicts with gmpxx.h definition
Product: [Fedora] Fedora Reporter: Paulo Andrade <paulo.cesar.pereira.de.andrade>
Component: pplAssignee: Roberto Bagnara <bagnara>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: high Docs Contact:
Priority: unspecified    
Version: rawhideCC: bagnara, dick, loganjerry, tcallawa
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: All   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-02-08 20:31:30 EST Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 877651    
Attachments:
Description Flags
ppl-gmp-5.1.0.patch none

Description Paulo Andrade 2013-01-29 07:17:12 EST
Build failure has the pattern:

---%<---
In file included from /usr/include/ppl.hh:25:0,
                 from sage/libs/ppl.cpp:264:
/usr/include/ppl-x86_64.hh:774:7: error: redefinition of 'class std::numeric_limits<__gmp_expr<__mpz_struct [1], __mpz_struct [1]> >'
 class numeric_limits<mpz_class> {
---%<---

Upstream commit correcting the problem:
http://www.cs.unipr.it/git/gitweb.cgi?p=ppl/ppl.git;a=commit;h=9f843aecc23981aec6ed1eaa8be06e6786a47f0d

Gentoo bug report:
https://bugs.gentoo.org/show_bug.cgi?id=447928
Comment 1 Paulo Andrade 2013-01-29 22:06:24 EST
Suggested correction with a "backport" patch:

Spec: http://pcpa.fedorapeople.org/ppl.spec
SRPM: http://pcpa.fedorapeople.org/ppl-1.0-3.fc19.4.src.rpm
Comment 2 Paulo Andrade 2013-01-30 08:42:11 EST
Commenting my own proposed spec, it is not required to write:

%if 0%{?fedora} >= 19
%patch0 -p1
%endif

because the patch itself is conditional to gmp version. So,
should be just:

%patch0 -p1
Comment 3 Paulo Andrade 2013-02-01 10:06:56 EST
Roberto, I just asked for comaintainership of ppl in rawhide, but
any other comment is welcome, particularly because I am afraid
of breaking anything due to a rebuild (what should not happen
but may break rpm dependencies, etc), as the word "hack" is
a bit too common in the last logs at
http://pkgs.fedoraproject.org/cgit/ppl.git/log/
Comment 4 Paulo Andrade 2013-02-01 10:37:01 EST
Adding Spot to CC as he may have some comments about it :-)

Not a big hurry on rebuilding ppl with the patch in
rawhide, but would make it easier for anybody attempting
to run fedora-review in my sagemath package.
Comment 5 Paulo Andrade 2013-02-01 10:38:17 EST
Created attachment 691622 [details]
ppl-gmp-5.1.0.patch

For easier visualization, the patch backported to ppl-1.0
Comment 6 Paulo Andrade 2013-02-04 08:14:40 EST
BTW, after the preapproved watchcommits and watchbugzilla
now I am receiving emails like this from
buildsys@fedoraproject.org:

ppl has broken dependencies in the rawhide tree:
On x86_64:
        ppl-java-javadoc-1.0-3.fc19.3.x86_64 requires jpackage-utils(x86-64)
On i386:
        ppl-java-javadoc-1.0-3.fc19.3.i686 requires jpackage-utils(x86-32)
On x86_64:
        ppl-java-1.0-3.fc19.3.x86_64 requires jpackage-utils(x86-64)
        ppl-java-1.0-3.fc19.3.x86_64 requires java(x86-64) >= 1:1.6.0
On i386:
        ppl-java-1.0-3.fc19.3.i686 requires jpackage-utils(x86-32)
        ppl-java-1.0-3.fc19.3.i686 requires java(x86-32) >= 1:1.6.0
On x86_64:
        ppl-utils-1.0-3.fc19.3.x86_64 requires libglpk.so.0()(64bit)
On i386:
        ppl-utils-1.0-3.fc19.3.i686 requires libglpk.so.0
On x86_64:
        ppl-swiprolog-1.0-3.fc19.3.x86_64 requires libswipl.so.6.2.4()(64bit)
On i386:
        ppl-swiprolog-1.0-3.fc19.3.i686 requires libswipl.so.6.2.4
Please resolve this as soon as possible.
Comment 7 Paulo Andrade 2013-02-04 09:03:19 EST
Corrections should be somewhat like:

-Requires:	jpackage-utils%{?_isa}
+Requires:	jpackage-utils

as jpackage-utils is noarch

Also

-Requires:	java%{?_isa} >= 1:1.6.0
+Requires:	java >= 1:1.6.0

is more likely to work, at least would work for
openjdk, that has ab explicit provides of
java = %{epoch}:%{javaver}

The others should be just a matter of a rebuild as
apparently ppl was not rebuilt wen those where
updated, e.g.:

$ rpm -qp --provides glpk-4.48-1.fc19.x86_64.rpm 
glpk = 4.48-1.fc19
glpk(x86-64) = 4.48-1.fc19
libglpk.so.33()(64bit)

so a rebuild would fix
On x86_64:
        ppl-utils-1.0-3.fc19.3.x86_64 requires libglpk.so.0()(64bit)
On i386:
        ppl-utils-1.0-3.fc19.3.i686 requires libglpk.so.0

I am unsure about the libswipl (right now not on fedora/rawhide)
but I suppose it would be automagically corrected if rebuilt with
latest swi-prolog in rawhide (needs testing).
Comment 8 Paulo Andrade 2013-02-04 10:13:54 EST
*** Bug 907477 has been marked as a duplicate of this bug. ***
Comment 9 Jerry James 2013-02-04 19:20:30 EST
According to the fedora_active_user script, Roberto has not been seen recently.  Last email to fedora-devel was 16 Feb 2010.  Last build of ppl by Roberto was 28 Feb 2011.  Also see bug 831376, which he has not replied to.  You may need to invoke the unresponsive maintainer policy:

http://fedoraproject.org/wiki/Policy_for_nonresponsive_package_maintainers
Comment 10 Roberto Bagnara 2013-02-05 04:45:06 EST
You can do what you like of course.  However, as I have already tried to communicate (perhaps using the wrong channels) I only need some help.  If you are willing to provide such help, please get in touch.
Comment 11 Paulo Andrade 2013-02-05 06:57:10 EST
(In reply to comment #10)
> You can do what you like of course.  However, as I have already tried to
> communicate (perhaps using the wrong channels) I only need some help.  If
> you are willing to provide such help, please get in touch.

I will be happy helping in whatever problem you may have, here on in
private email.
I believe you work too much on making ppl itself and not much packaging
work that forgot most steps of how to handle it :-)
I suggest at first just having
https://fedoraproject.org/wiki/Join_the_package_collection_maintainers
in a bookmark, and if you were inactive for more than 6 months, should
need to run "fedora-packager-setup" again to revalidate your account.
After that you should be able to login at
https://admin.fedoraproject.org/pkgdb/acls/name/ppl
and give me comaintainership if you wish, but it is not required.
Actually, I have "provenpackager" power, but I am not willing to abuse
it (in fear of breaking some magic somewhere and lacking power to fix
it elsewhere, and gcc is linked to ppl...).
Comment 12 Paulo Andrade 2013-02-07 09:12:24 EST
If nobody replies, I will work on correcting the package for all
problems I know of in this weekend.
I would still prefer to be a comaintainer to do that... but
preapproved watchbugzilla whould help to quickly learn of any
issues.
Comment 13 Roberto Bagnara 2013-02-07 10:36:14 EST
(In reply to comment #11)
> I will be happy helping in whatever problem you may have, here on in
> private email.

Yes, please: private email is better.

> I believe you work too much on making ppl itself and not much packaging
> work that forgot most steps of how to handle it :-)

Precisely.  In addition, when I first packaged the PPL I did it
because nobody else was doing it.  But I have never been the right
person for that kind of work.  In contrast, I am the right person
upstream;  even though I know from experience that package (co)maintainers
very rarely keep contact with upstream people;  they do not even subscribe
the "announce" mailing lists...;  let alone ask for advice;  I have never understood why.

> I suggest at first just having
> https://fedoraproject.org/wiki/Join_the_package_collection_maintainers
> in a bookmark,

OK.

> and if you were inactive for more than 6 months, should
> need to run "fedora-packager-setup" again to revalidate your account.
> After that you should be able to login at
> https://admin.fedoraproject.org/pkgdb/acls/name/ppl
> and give me comaintainership if you wish, but it is not required.

Done.
Comment 14 Tom "spot" Callaway 2013-02-07 13:23:52 EST
(In reply to comment #4)
> Adding Spot to CC as he may have some comments about it :-)
> 
> Not a big hurry on rebuilding ppl with the patch in
> rawhide, but would make it easier for anybody attempting
> to run fedora-review in my sagemath package.

Patch looks sensible to me.
Comment 15 Paulo Andrade 2013-02-07 14:04:42 EST
Thanks! With "comaintainer hat", and asking for advice to tomspur
(my fedora packager sponsor) I gone ahead and submitted a package
that should correct all known issues in rawhide. I also verified
and apparently there are no problems in f18, at least no
uninstallable ppl subpackage.
Comment 16 Paulo Andrade 2013-02-08 20:31:30 EST
Problem was specific to rawhide and update packages
are already available.